
private:


static bool poda_aux(int x, Node2*& m) {
  /* Pre: m = M. M apunta a una jerarquía de nodos A cuyos valores son todos distintos. */
  /* Post: Si x es el valor de uno de los nodos de A, el resultado es cierto y 
     m apunta a una jerarquía de nodos que es el resultado de eliminar de A el 
     nodo cuyo valor es x y todos sus descendientes; en otro caso, el resultado es falso y m apunta a A. */
  bool encontrado; 
  if (m != nullptr) {
     if (m->info == x) {
        encontrado = true;
        esborra_estruct(m);
	m = nullptr;
     }
     else {
        encontrado = poda_aux(x, m->segE);
        if (not encontrado) encontrado = poda_aux(x, m->segD); 
     }
  }
  else encontrado = false;
  return encontrado;
}



public:

bool poda_subarbre(int x) {
  return poda_aux(x, primer);
}


/*
Ejemplo 1: 
1 2 5 0 0 4 7 0 0 6 0 0 3 0 0 
4

Ejemplo 2: 
5 2 0 0 7 6 0 0 8 0 0
3

*/
