public:

// - sustituir las hojas de un árbol que contengan el valor x por el
// árbol as -

void substGen(const T &x, const ArbreGen &as) {
/* Pre: A és el valor inicial del p.i.; el tipus T té l'operació ==; 
   as no és un arbre general buit */
/* Post: el p.i. és com A però havent substituit les fulles que
 contenien x per l'arbre as */
  subst_node(primer, x, as.primer);
}


private: 

static void subst_node(Node* &n, const T &x, Node* ns) {
/* Pre: cert */ 
/* Post: els nodes de la jerarquia de nodes que comença al node
 apuntat per n tals que el seu camp info valia x i no tenien següents
 han estat substituits per una còpia de la jeraquia de nodes que
 comença al node apuntat per ns */
if (n == NULL) return;
int ari = (n->seg).size();
if (n->info == x and ari == 0) {
  delete n; 
  n = copia_jerarquia(ns);
}
else {
  for (int i = 0; i < ari; ++i) {
    subst_node(n->seg[i], x, ns);
  }
} 
}

