public:

/* sustituir las hojas de un árbol que contengan el valor x por el
   árbol as */
void substNari(const T &x, const ArbreNari &as) { 
/* Pre: A és el valor inicial del p.i.; el tipus T té l'operació == */
/* Post: el p.i. és com A però havent substituit les fulles que
 contenien x per l'arbre as */
subst_nodeNari(primer, x, as.primer);
}


private: 

static void subst_nodeNari(Node* &n, const T &x, Node* ns) {
/* Pre: cert */ 
/* Post: els nodes de la jerarquia de nodes que comença al node
 apuntat per n tals que el seu camp info valia x i no tenien següents
 han estat substituits per una còpia de la jeraquia de nodes que
 comença al node apuntat per ns */
if (n != NULL) {
  bool b = (n->info == x);
  int i = 0; 
  int ari = (n->seg).size();
  // ¿Qué comprueba este while?
  while (b and i < ari) {
    if (n->seg[i] == NULL) ++i; 
    else b = false;
  }
  if (b) {
    delete n; 
    n = copia_jerarquia(ns);
  }
  else {
    for (i = 0; i < ari; ++i) {
      subst_nodeNari(n->seg[i], x, ns);
    }
  } 
 }
}





